{ pkgs ? import <nixpkgs> { } }:
with pkgs;
mkShell rec {
  name = "tfc-env";

  nativeBuildInputs = [
    gcc
    stdenv
    gnumake
    gdb
    pkg-config
    makeWrapper
  ];

  buildInputs = [
    hugo
    go
    nodejs
    clojure
    clojure-lsp
    clj-kondo
    sbcl
    openssl

    clippy
    rustc
    cargo
    rustfmt
    rust-analyzer
    corrosion
  ];
  
  shellHook = ''
  alias hss='hugo server --noHTTPCache'
  '';
}
