use std::{env, io};
use actix_web::{middleware, web, App, HttpServer, get, post, Responder, http::header::ContentType, HttpResponse, HttpRequest, http::{StatusCode, Method}};

#[actix_web::main]
async fn main() -> io::Result<()> {
    env::set_var("RUST_LOG", "actix_web=debug,actix_server=info");
    env_logger::init();

    HttpServer::new(|| {
        App::new()
        // enable logger - always register actix-web Logger middleware last
            .wrap(middleware::Logger::default())
        // register HTTP requests handlers
            .service(form)
    })
        .bind("0.0.0.0:4242")?
        .run()
        .await
}

#[post("/health-form")]
async fn form(req: HttpRequest) -> HttpResponse {
    println!("{req:?}");
    HttpResponse::Ok().respond_to(&req)
}
