(load "~/quicklisp/setup.lisp")
(ql:quickload :hunchentoot)
(ql:quickload :clack)
(ql:quickload :drakma)
(ql:quickload :com.inuoe.jzon)
(ql:quickload :rfc2388)

(uiop:define-package tfc-server
  (:use :cl :hunchentoot :com.inuoe.jzon :clack))

(in-package :tfc-server)

(defun handler (env) '(200 nil ("Hello World, bleh!")))

(clack:stop (clack:clackup (lambda (env)
                                         '(200 nil ("Hello, World!")))
(clack.handler:stop *clack-server*)

(defparameter *clack-server* (clack:clackup (lambda (env)
                                         (funcall 'handler env))))


(hunchentoot:start (make-instance 'hunchentoot:easy-acceptor :port 4242))

(hunchentoot:define-easy-handler (say-yo :uri "/yo") (name)
  (setf (hunchentoot:content-type*) "text/plain")
  (format nil "Hey~@[ ~A~]!" name))

(hunchentoot:define-easy-handler (respond :uri "/health-form") ()
  (setf (hunchentoot:content-type*) "application/json")
  (let ((request-type (hunchentoot:request-method hunchentoot:*request*)))
    (cond ((eq request-type :get) nil)
          ((eq request-type :post)
           (uiop:println hunchentoot:*request*)
           (setq *last* hunchentoot:*request*)
           (setq *stream* (hunchentoot::content-stream hunchentoot:*request*))
           (let* ((stream (hunchentoot::content-stream hunchentoot:*request*))
                  (data (hunchentoot::get-post-data :request *last*))
                  )
             (uiop:println (sb-sys:fd-stream-fd stream))
             (uiop:println (open-stream-p stream))
             (uiop:println (write-byte 8 stream))
             ;; (uiop:println (flex:octets-to-string data))

             ;; (let* ((header (rfc2388:parse-header "multipart/form-data" :value))
             ;;        (boundary (or (assoc "boundary" (rfc2388:header-parameters header)
             ;;                             :test #'string-equal)
             ;;                      (error "Form data is missing a boundary: ~S"
             ;;                             "multipart/form-data"))))
             ;;   (uiop:println (rfc2388:parse-mime data boundary)))
             ;; )

             (uiop:println "OTHER")
             (uiop:println (hunchentoot::parse-multipart-form-data *last* *hunchentoot-default-external-format*))
             ;; (uiop:println (hunchentoot::headers-in *last*))
             ;; (uiop:println (hunchentoot::get-request-data stream))
             ;; (uiop:println (rfc2388:parse-mime data boundary))
             ;; (let* ((data (hunchentoot:raw-post-data :force-text t))
             ;;        (json-obj (com.inuoe.jzon:parse data))
             ;;        )
             ;;   ;; (print (format nil "Json: ~A" (com.inuoe.jzon:stringify json-obj)))
             ;;   (uiop:println "Received Health Form")
             ;;   (render-json json-obj)
             ;;   (setq last json-obj)
             ;;   (process-form json-obj)
             ;;   data)
             )))))

(defun display-stream (stream)
  (loop for line = (read-line stream nil)
        while line do (format t "~A~%" line)))

(defvar *last*)
(defvar *stream*)
(defvar *token* "boFFRM68vvXbO-DO7S9YDg86lHX027-hd07mn0dh")

(defun print-hash-entry (key value)
  (format t "~S: ~S~%" key value))

(defun process-form (form)
  "Processes the form and sends it on"
  (let ((firstname (gethash "firstname" form))
        (lastname (gethash "lastname" form))
        (parentfirstname (gethash "parentfirstname" form))
        (parentlastname (gethash "parentlastname" form))
        (street (gethash "street" form))
        (city (gethash "city" form))
        (state (gethash "state" form))
        (zip (gethash "zip" form))
        (cellphone (gethash "cellphone" form))
        (homephone (gethash "homephone" form))
        (add-emergency-contact (gethash "add-emergency-contact" form))
        (add-emergency-contact-phone (gethash "add-emergency-contact-phone" form))
        (doctorname (gethash "doctorname" form))
        (doctorcity (gethash "doctorcity" form))
        (doctorphone (gethash "doctorphone" form))
        (medical-coverage (gethash "medical-coverage" form))
        (insurance-name (gethash "insurance-name" form))
        (policy-number (gethash "policy-number" form))
        (image (gethash "image" form))
        (agreement (gethash "agreement" form))
        (allergies (gethash "allergies" form))
        (allergies-other (gethash "allergies-other" form))
        (specific-allergies (gethash "specific-allergies" form))
        (allergic-treatment (gethash "allergic-treatment" form))
        (conditions (gethash "conditions" form))
        (tetanus-shot (gethash "tetanus-shot" form))
        (swimming-ability (gethash "swimming-ability" form))
        (medication-schedule (gethash "medication-schedule" form))
        (other-notes (gethash "other-notes" form))
        (age (gethash "age" form)))
    (uiop:println "---")
    (maphash 'print-hash-entry form)
    (uiop:println "---")))


(defun render-json (object)
  (uiop:println (format nil "Json: ~A" (com.inuoe.jzon:stringify object))))

